
int enablePin = 11;
int in1Pin = 10;
int in2Pin = 9;
int buttonPin = 7;
int potPin = 0;

int motorSpeed = 0;
boolean reverse = false; // A boolean data type is either true or false (1 or 0, HIGH or LOW)

void setup() {
  pinMode(in1Pin, OUTPUT);
  pinMode(in2Pin, OUTPUT);
  pinMode(enablePin, OUTPUT);
  pinMode(buttonPin, INPUT);
}

void loop(){
  motorSpeed = analogRead(potPin)/4; // Remember: analog input is 0-1023 and analog output is 0-255, so we need to scale it. In this case, it can easily be done by dividing by 4.
  reverse = digitalRead(buttonPin); // if the button is pressed, the motor will reverse. if not, it will rotate normally.
  setMotor(motorSpeed, reverse);
}

void setMotor(int mSpeed, boolean reverse){
  analogWrite(enablePin, mSpeed);
  digitalWrite(in1Pin, !reverse); // the ! means NOT. So, !reverse means "the opposite of reverse".
  digitalWrite(in2Pin, reverse);
}
