
int enablePin = 11;
int in1Pin = 10;
int in2Pin = 9;

int buttonPin = 7;
int buttonState; // If no value is given, an int defaults to 0

int motorSpeed = 255;
boolean reverse = false; // A boolean data type is either true or false (1 or 0, HIGH or LOW)

void setup() {
  pinMode(in1Pin, OUTPUT);
  pinMode(in2Pin, OUTPUT);
  pinMode(enablePin, OUTPUT);
  pinMode(buttonPin, INPUT_PULLUP); //this way we don't need to have a pull up resistors!
}

void loop(){
  buttonState = digitalRead(buttonPin);
  
  if (buttonState == HIGH){
    setMotor(motorSpeed, reverse);
  }
  else{
     setMotor(motorSpeed, !reverse);
  }
  
}

// This function turns the motor by setting both inputs on L293D to opposites and enable pin to analog output value
void setMotor(int mSpeed, boolean reverse){
  analogWrite(enablePin, mSpeed);
  digitalWrite(in1Pin, !reverse); // the ! means NOT. So, !reverse means "the opposite of reverse".
  digitalWrite(in2Pin, reverse);
}

// This function stops the motor by setting both inputs on L293D to low
void stopMotor(){
  digitalWrite(in1Pin, 0); // the ! means NOT. So, !reverse means "the opposite of reverse".
  digitalWrite(in2Pin, 0);
}
