
int enablePin = 11;
int in1Pin = 10;
int in2Pin = 9;

int motorSpeed = 255; // How fast? 0-255 (analog output range)
boolean reverse = false; // A boolean data type is either true or false (1 or 0, HIGH or LOW)

boolean motorActive = false; // Is our motor active?
unsigned long motorStartTime; // When did we start the motor (in milliseconds, measured from the start of the program) IMPORTANT: use unsigned long data type and it will count for about 50 days before it starts over (supposedly).
int motorDuration = 300; // in milliseconds: 1000 = 1 second
int motorInterval = 2000; // How often should the motor be triggered (in milliseconds)
void setup() {
  pinMode(in1Pin, OUTPUT);
  pinMode(in2Pin, OUTPUT);
  pinMode(enablePin, OUTPUT);
  Serial.begin(9600);
}

void loop(){
 
  // the modulo operator(%) calculates the remainder when one integer is divided by another. So below: if millis() divided by 5000 has no remainder (== 0)
  if (millis() % motorInterval == 0){
    if (motorActive == false){
      motorActive = true;
      motorStartTime = millis();
      
      Serial.print("Motor started at: ");
      Serial.println(motorStartTime);
    }
  }
  
  if (motorActive == true){
    if (millis() < motorStartTime + motorDuration){
      setMotor(motorSpeed, reverse);
      
    }
    else {
      motorActive = false;
      stopMotor();
      reverse = !reverse; //reverse the direction of motor every time motor goes off
      
      Serial.print("Motor stopped at: ");
      Serial.println(motorStartTime + motorDuration);
    }
  }

}

// This function turns the motor by setting both inputs on L293D to opposites and enable pin to analog output value
void setMotor(int mSpeed, boolean reverse){
  analogWrite(enablePin, mSpeed);
  digitalWrite(in1Pin, !reverse); // the ! means NOT. So, !reverse means "the opposite of reverse".
  digitalWrite(in2Pin, reverse);
}

// This function stops the motor by setting both inputs on L293D to low
void stopMotor(){
  digitalWrite(in1Pin, 0); // the ! means NOT. So, !reverse means "the opposite of reverse".
  digitalWrite(in2Pin, 0);
}


