// Motor 1
int enablePin1 = 11;
int in1Pin = 10;
int in2Pin = 9;

int motorSpeed1 = 255; // How fast? 0-255 (analog output range)
int buttonPin1 = 7;
boolean buttonState1;

// Motor 2
int enablePin2 = 6;
int in3Pin = 5;
int in4Pin = 4;

int motorSpeed2 = 255; 

int buttonPin2 = 3;
boolean buttonState2;


boolean motorActive = false; // Is our motor active?
unsigned long motorStartTime; // When did we start the motor (in milliseconds, measured from the start of the program) IMPORTANT: use unsigned long data type and it will count for about 50 days before it starts over (supposedly).
int motorDuration = 1000; // in milliseconds: 1000 = 1 second
int motorInterval = 10000; // How often should the motor be triggered (in milliseconds)

void setup() {
  pinMode(in1Pin, OUTPUT);
  pinMode(in2Pin, OUTPUT);
  pinMode(enablePin1, OUTPUT);
  pinMode(buttonPin1, INPUT_PULLUP);

  pinMode(in3Pin, OUTPUT);
  pinMode(in4Pin, OUTPUT);
  pinMode(enablePin2, OUTPUT);
  pinMode(buttonPin2, INPUT_PULLUP);
}

void loop(){
  buttonState1 = digitalRead(buttonPin1);
  buttonState2 = digitalRead(buttonPin2);

  setMotor(1, motorSpeed1, buttonState1);
  setMotor(2, motorSpeed2, buttonState2);
}

// This function turns the motor by setting both inputs on L293D to opposites and enable pin to analog output value
void setMotor(int whichMotor, int mSpeed, boolean reverse){
  if (whichMotor == 1){
    analogWrite(enablePin1, mSpeed);
    digitalWrite(in1Pin, !reverse); // the ! means NOT. So, !reverse means "the opposite of reverse".
    digitalWrite(in2Pin, reverse);
  }
  else if (whichMotor == 2){
    analogWrite(enablePin2, mSpeed);
    digitalWrite(in3Pin, !reverse); // the ! means NOT. So, !reverse means "the opposite of reverse".
    digitalWrite(in4Pin, reverse);
  }
}

// This function stops the motor by setting both inputs on L293D to low
void stopMotor(int whichMotor){
  if (whichMotor == 1){
    digitalWrite(in1Pin, 0); // the ! means NOT. So, !reverse means "the opposite of reverse".
    digitalWrite(in2Pin, 0);
  }
  else if (whichMotor == 2){
    digitalWrite(in3Pin, 0); // the ! means NOT. So, !reverse means "the opposite of reverse".
    digitalWrite(in4Pin, 0);
  }

}






